#include <iostream>
#include <string>

using namespace std;

int vrednost(int n,int p,string s)
{
    int i,j,mv=0,v;
    for (i=p+1;i<n-2;i++)
    {
        v=0;
        for (j=p;j<=i;j++)
        {
            if (s[j]==s[i+1+(i-j)])
                v++;
        }
        if (v!=0)
            v+=vrednost(n,i+1,s);
        if (mv<v)
            mv=v;
    }
    return mv;
}

int main()
{
    string s;
    cin >> s;
    int n=s.length();
    int r=vrednost(n,0,s);
    cout << r;
    return 0;
}